#include "fichero.h"
#include <ctype.h>
#include <strings.h>
/* 1 Bien
   0 fallo
  -1 comentario  */
GtkWidget *entrycompartido,*entrycompartido_cargar;  

int parse_line(const unsigned char *line,unsigned char **com,unsigned char **val)
{
  int i,j;
  
  /* Saltar espacios y tabuladores */
  for (i=0;line[i]==' ' || line[i]=='\t';i++);
  
  /* lineas vacias y comentarios */
  if (!line[i] || line[i]=='\n' || line[i]=='#')
    return -1;
    
  /* Reservamos memoria */
  *com=(unsigned char *)nmalloc(1);
  (*com)[0]='\0';
  
  for (j=0;(isalpha(line[i]) ||line[i]=='_' || line[i]=='-');i++)
     { 
       if (line[i]=='-' || line[i]=='_')
          continue;
       *com=(unsigned char *)nrealloc(*com,j+2);
       (*com)[j]=line[i];
       (*com)[j+1]='\0';
       ++j;
     }
  
  /* El proximo caracter deberia ser espacio o '=' */
  if (!isspace(line[i]) && (line[i]!='='))
   { free(*com);
     return 0; 
   }
   
  /* Saltar espacios antes del '=' */
  for (;isspace(line[i]);i++);
  
  /* Si no hay '=' salir */
  /* es que es una opcion de boton */
  if (line[i]!='=')
    return 1;
   
   
  /*Saltar espacios despues del '=' */
  for (++i;isspace(line[i]);i++);
  
  
  /*Cojer la ultima posicion */
  for (j=i;line[i] && line[i]!='\n';i++);
  
  /* Reservar mem. para val y copiarla desde line */
  (*val)=(unsigned char *)nmalloc(i-j+1);
  strncpy((char*)*val,(char*)line+j,i-j);
  (*val)[i-j]='\0';
  return 1;
}


void *nmalloc(size_t size)
{ void *res;
  
  res=malloc(size);
  return res;
}

void* nrealloc(void *obj,size_t size)
{
 void *res;
 
 if(obj)
    res=realloc(obj,size);
 else
    res=malloc(size);
 return(res);
}

char *lee_linea(FILE *f)
{
  char *line;
  int i,bufsize,c;
  
  i=0;
  bufsize=DYNAMIC_LINE_BUFFER;
  line=nmalloc(bufsize);
  
  while((c=getc(f))!=EOF && c!='\n')
  { 
    if (i>bufsize-1)
       line=(char*)nrealloc(line,(bufsize<<=1));
    line[i++]=c;
  }
  
  if(c==EOF && !i)
  { free(line);
    return NULL;
  }
  
  if (i==bufsize)
     line=(char*)nrealloc(line,i+1);
  line[i]='\0';
  return line;
}

/* Despliega un dialogo y graba el fichero de configuracion usando guardafich()
 */
#ifdef GTK_HAVE_FEATURES_1_1_0
void grabafichero(GtkWidget *win,GtkWidget *widget)
#else
void grabafichero(GtkWidget *widget,GtkWidget *win)
#endif
{   
/*  if (!*gtk_entry_get_text(GTK_ENTRY(datos.proyecto)) || 
  	  !*gtk_file_selection_get_filename(GTK_FILE_SELECTION(win)) )
     { Gtkerror(_("You must give a project name"));
       return;
     }
*/ 
 guardafich(gtk_file_selection_get_filename(GTK_FILE_SELECTION(win)));
  gtk_widget_destroy(win);
}

/* Guarda el entorno (Widget *datos) en el fichero nomfichero
 */
void guardafich(char *nomfichero)
{ FILE *f;

  printf("Fichero a grabar : %s\n",nomfichero);
  f=fopen(nomfichero,"w");
  if (f==NULL)
     perror("fichero a grabar");
/***********************************************************/
/*             Parte de arriba                             */
/***********************************************************/

  if (*gtk_entry_get_text(GTK_ENTRY(datos.proyecto)))
  	{ fwrite("NOMBRE=",sizeof(char),7,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
  	  fwrite(gtk_entry_get_text(GTK_ENTRY(datos.proyecto)),sizeof(char),
  	  		GTK_ENTRY(datos.proyecto)->text_length,f);
#else
  	  fwrite(gtk_entry_get_text(GTK_ENTRY(datos.proyecto)),sizeof(char),
  	  		GTK_ENTRY(datos.proyecto)->nchars,f);
#endif
  	  fwrite("\n",sizeof(char),1,f);
  	 }
       
  if (*gtk_entry_get_text(GTK_ENTRY(datos.url)))
    { fwrite("URL=",sizeof(char),4,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
      fwrite(gtk_entry_get_text(GTK_ENTRY(datos.url)),sizeof(char),
         GTK_ENTRY(datos.url)->text_length,f);
#else 
      fwrite(gtk_entry_get_text(GTK_ENTRY(datos.url)),sizeof(char),
         GTK_ENTRY(datos.url)->nchars,f);
#endif
      fwrite("\n",sizeof(char),1,f);
    }
  
   if (*gtk_entry_get_text(GTK_ENTRY(datos.fichero)))
    {  fwrite("FICHERO=",sizeof(char),8,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.fichero)),sizeof(char),
         GTK_ENTRY(datos.fichero)->text_length,f);
#else
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.fichero)),sizeof(char),
         GTK_ENTRY(datos.fichero)->nchars,f);
#endif
      fwrite("\n",sizeof(char),2,f);
    }

/***********************************************************/
/* 		General					  */
/***********************************************************/

  if(*gtk_entry_get_text(GTK_ENTRY(datos.destino)))
    { fwrite("DESTINO=",sizeof(char),8,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.destino)),sizeof(char),
         GTK_ENTRY(datos.destino)->text_length,f);
#else
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.destino)),sizeof(char),
         GTK_ENTRY(datos.destino)->nchars,f);
#endif
      fwrite("\n",sizeof(char),1,f);
    }

  if(*gtk_entry_get_text(GTK_ENTRY(datos.logfile)))
     { fwrite("LOGFILE=",sizeof(char),8,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.logfile)),sizeof(char),
         GTK_ENTRY(datos.logfile)->text_length,f);
#else
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.logfile)),sizeof(char),
         GTK_ENTRY(datos.logfile)->text_length,f);
#endif
      fwrite("\n",sizeof(char),1,f);
    }

  if (GTK_TOGGLE_BUTTON(datos.anadir_log)->active)
     { fwrite("ANADIRLOG=TRUE",sizeof(char),15,f);
       fwrite("\n",sizeof(char),1,f);
    }

  if (*gtk_entry_get_text(GTK_ENTRY(datos.tries)))
  	 { fwrite("TRIES=",sizeof(char),6,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
  	   fwrite(gtk_entry_get_text(GTK_ENTRY(datos.tries)),sizeof(char),
  	   		GTK_ENTRY(datos.tries)->text_length,f);
#else
  	   fwrite(gtk_entry_get_text(GTK_ENTRY(datos.tries)),sizeof(char),
  	   		GTK_ENTRY(datos.tries)->nchars,f);
#endif
  	   fwrite("\n",sizeof(char),1,f);
  	 }
/***********************************************************/
/*          Recursivity 			           */
/***********************************************************/

  if (GTK_TOGGLE_BUTTON(datos.recursivo)->active)
     { fwrite("RECURSIVO=TRUE",sizeof(char),14,f);
       fwrite("\n",sizeof(char),1,f);
    }

  if (*gtk_entry_get_text(GTK_ENTRY(datos.niveles)))
     { fwrite("NIVELES=",sizeof(char),8,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.niveles)),sizeof(char),
         GTK_ENTRY(datos.niveles)->text_length,f);
#else
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.niveles)),sizeof(char),
         GTK_ENTRY(datos.niveles)->nchars,f);
#endif
      fwrite("\n",sizeof(char),1,f);
    }

  if (*gtk_entry_get_text(GTK_ENTRY(datos.dominios)))
    { fwrite("DOMINIOS=",sizeof(char),9,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.dominios)),sizeof(char),
         GTK_ENTRY(datos.dominios)->text_length,f);
#else
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.dominios)),sizeof(char),
         GTK_ENTRY(datos.dominios)->nchars,f);
#endif
      fwrite("\n",sizeof(char),1,f);
    }

 if(GTK_TOGGLE_BUTTON(datos.nc)->active)
   { fwrite("EXISTINGFILES=TRUE",sizeof(char),19,f);
     fwrite("\n",sizeof(char),1,f);
   }

 if (GTK_TOGGLE_BUTTON(datos.convert)->active)
	{ fwrite("CONVERT=TRUE",sizeof(char),12,f);
	  fwrite("\n",sizeof(char),1,f);
   } 

/******************************************************/
/*                   FTP                              */
/*****************************************************/
  if (GTK_TOGGLE_BUTTON(datos.continuar)->active)
     { fwrite("CONTINUAR=TRUE",sizeof(char),14,f);
       fwrite("\n",sizeof(char),1,f);
    }

  if (GTK_TOGGLE_BUTTON(datos.seguir_ftp)->active)
     { fwrite("SEGUIRFTP=TRUE",sizeof(char),15,f);
       fwrite("\n",sizeof(char),1,f);
   }

  if (*gtk_entry_get_text(GTK_ENTRY(datos.excluir_ftp)))
    { fwrite("EXCLUIR_FTP=",sizeof(char),12,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.excluir_ftp)),sizeof(char),
         GTK_ENTRY(datos.excluir_ftp)->text_length,f);
#else
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.excluir_ftp)),sizeof(char),
         GTK_ENTRY(datos.excluir_ftp)->nchars,f);
#endif
      fwrite("\n",sizeof(char),1,f);
    }

 if(*gtk_entry_get_text(GTK_ENTRY(datos.userftp)))
    { fwrite("USERFTP=",sizeof(char),8,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.userftp)),sizeof(char),
         GTK_ENTRY(datos.userftp)->text_length,f);
#else
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.userftp)),sizeof(char),
         GTK_ENTRY(datos.userftp)->nchars,f);
#endif
      fwrite("\n",sizeof(char),1,f);
    }

 if(*gtk_entry_get_text(GTK_ENTRY(datos.passftp)))
    { fwrite("PASSFTP=",sizeof(char),8,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.passftp)),sizeof(char),
         GTK_ENTRY(datos.passftp)->text_length,f);
#else
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.passftp)),sizeof(char),
         GTK_ENTRY(datos.passftp)->nchars,f);
#endif
      fwrite("\n",sizeof(char),1,f);
    }

/******************************************************/
/*                   Advanced                         */
/*****************************************************/


  if (*gtk_entry_get_text(GTK_ENTRY(datos.accept)))
    { fwrite("ACCEPT=",sizeof(char),7,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.accept)),sizeof(char),
         GTK_ENTRY(datos.accept)->text_length,f);
#else
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.accept)),sizeof(char),
         GTK_ENTRY(datos.accept)->nchars,f);
#endif
      fwrite("\n",sizeof(char),1,f);
    }

  if (*gtk_entry_get_text(GTK_ENTRY(datos.reject)))
    { fwrite("REJECT=",sizeof(char),7,f);
#ifdef GTK_HAVE_FEATURES_1_1_0
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.reject)),sizeof(char),
         GTK_ENTRY(datos.reject)->text_length,f);
#else
       fwrite(gtk_entry_get_text(GTK_ENTRY(datos.reject)),sizeof(char),
         GTK_ENTRY(datos.reject)->nchars,f);
#endif
      fwrite("\n",sizeof(char),2,f);
    }

  if (GTK_TOGGLE_BUTTON(datos.parent)->active)
	{ fwrite("PARENT=TRUE",sizeof(char),11,f);
          fwrite("\n",sizeof(char),1,f);
	}


   if (GTK_TOGGLE_BUTTON(datos.mirror)->active)
  	{ fwrite("MIRROR=TRUE",sizeof(char),11,f);
  	  fwrite("\n",sizeof(char),1,f);
  	}

  fclose(f);
  
}

void grabarcomo(GtkWidget *widget,gpointer data)
{  static GtkWidget *window=NULL;
  

  if (!window)
  {
   window=gtk_file_selection_new(_("Project Name"));

  gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(window));
  gtk_signal_connect(GTK_OBJECT(window),"delete_event",
        	GTK_SIGNAL_FUNC(gtk_widget_destroyed),&window);
  gtk_signal_connect(GTK_OBJECT(window),"destroy",
        	GTK_SIGNAL_FUNC(gtk_widget_destroyed),&window);
  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(window)->cancel_button),
        	"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(window));

   gtk_container_border_width(GTK_CONTAINER(window),10);                
  gtk_file_selection_set_filename(GTK_FILE_SELECTION(window),datos.homewget);


   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(window)->ok_button),
     "clicked",GTK_SIGNAL_FUNC(grabafichero),GTK_OBJECT(window));
  }

  if (!GTK_WIDGET_VISIBLE(window))
     gtk_widget_show_all(window);
  else
     gtk_widget_destroy(window);
}

void grabar(GtkWidget *widget,gpointer data)
{  

  if (datos.hayfichero)
     guardafich(datos.ficheroopc);
  else
 	grabarcomo(widget,data);
}

/* Inicializa la variable pro
 */
void inipro(struct proyecto *pro)
{
  pro->nombre=(char *) malloc(100);
  strcpy(pro->nombre,"Nuevo proyecto"); 
  pro->URL=(char *) malloc(100);
  strcpy(pro->URL,"localhost");
  pro->ficheroURL=(char *) malloc(100);
  strcpy(pro->ficheroURL,"");
  pro->ficheroLOG=(char *) malloc(100);
  strcpy(pro->ficheroLOG,"");
  pro->niveles="1";
  pro->recursivo=0;
  pro->dirdestino=(char *) malloc(100);
  strcpy(pro->dirdestino,getenv("HOME"));
  pro->continuar=1;
  pro->seguir_a_ftp=1;
  pro->excluir_ftp=(char *) malloc(100);
  strcpy(pro->excluir_ftp,"");
  pro->dominios=(char *) malloc(100);
  strcpy(pro->dominios,"");
  pro->aceptar = (char *)malloc(100);
  strcpy(pro->aceptar,"");
  pro->rechazar=(char *) malloc(100);
  strcpy(pro->rechazar,"");
  pro->anadirLOG=0;
  pro->parent=0;
  pro->nc=0;
  pro->convert=0;
}   


/* Libera la variable pro 
 */
void finpro(struct proyecto *pro)
{
   free(pro->nombre);
   free(pro->URL);
   free(pro->ficheroURL);
   free(pro->ficheroLOG);
   free(pro->dirdestino);
   free(pro->dominios);
   free(pro->rechazar);
   free(pro->excluir_ftp);
   free(pro->niveles);
   
   
}

/* Asigna al entorno (Widget *datos) los valores de pro
 */
void update(struct proyecto pro)
{
 
   gtk_entry_set_text(GTK_ENTRY(datos.proyecto),pro.nombre);
   gtk_entry_set_text(GTK_ENTRY(datos.destino),pro.dirdestino);
   gtk_entry_set_text(GTK_ENTRY(datos.url),pro.URL);
   gtk_entry_set_text(GTK_ENTRY(datos.logfile),pro.ficheroLOG);
   if(pro.recursivo)
      GTK_TOGGLE_BUTTON(datos.recursivo)->active=TRUE;
   else
      GTK_TOGGLE_BUTTON(datos.recursivo)->active=FALSE;
   gtk_entry_set_text(GTK_ENTRY(datos.fichero),pro.ficheroURL);
   gtk_entry_set_text(GTK_ENTRY(datos.accept),pro.aceptar);
   gtk_entry_set_text(GTK_ENTRY(datos.reject),pro.rechazar);
   gtk_entry_set_text(GTK_ENTRY(datos.dominios),pro.dominios);
   if(pro.continuar)
      GTK_TOGGLE_BUTTON(datos.continuar)->active=TRUE;
   else
      GTK_TOGGLE_BUTTON(datos.continuar)->active=FALSE;
   if(pro.seguir_a_ftp)
      GTK_TOGGLE_BUTTON(datos.seguir_ftp)->active=TRUE;
   else
      GTK_TOGGLE_BUTTON(datos.seguir_ftp)->active=FALSE;
   if(pro.anadirLOG)
      GTK_TOGGLE_BUTTON(datos.anadir_log)->active=TRUE;
   else
      GTK_TOGGLE_BUTTON(datos.anadir_log)->active=FALSE;
   gtk_entry_set_text(GTK_ENTRY(datos.excluir_ftp),pro.excluir_ftp);
   gtk_entry_set_text(GTK_ENTRY(datos.niveles),pro.niveles);

   if(pro.nc)
	  GTK_TOGGLE_BUTTON(datos.nc)->active=TRUE;
   else
	  GTK_TOGGLE_BUTTON(datos.nc)->active=FALSE;
   
   if(pro.convert)
	  GTK_TOGGLE_BUTTON(datos.convert)->active=TRUE;
   else
	  GTK_TOGGLE_BUTTON(datos.convert)->active=FALSE;

}

/* Funcion que lee el entorno y lo coloca en pro (que debe estar inicializada)
 */
void consult(struct proyecto *pro)
{
   pro->nombre = gtk_entry_get_text(GTK_ENTRY(datos.proyecto));
   pro->dirdestino = gtk_entry_get_text(GTK_ENTRY(datos.destino));
   pro->URL = gtk_entry_get_text(GTK_ENTRY(datos.url));
   pro->ficheroLOG = gtk_entry_get_text(GTK_ENTRY(datos.logfile));
   pro->recursivo = (GTK_TOGGLE_BUTTON(datos.recursivo)->active==TRUE);
   pro->ficheroURL = gtk_entry_get_text(GTK_ENTRY(datos.fichero));
   pro->aceptar= gtk_entry_get_text(GTK_ENTRY(datos.accept));
   pro->rechazar = gtk_entry_get_text(GTK_ENTRY(datos.reject));
   pro->dominios = gtk_entry_get_text(GTK_ENTRY(datos.dominios));
   pro->continuar = (GTK_TOGGLE_BUTTON(datos.continuar)->active==TRUE);
   pro->seguir_a_ftp=(GTK_TOGGLE_BUTTON(datos.seguir_ftp)->active==TRUE);
   pro->anadirLOG = (GTK_TOGGLE_BUTTON(datos.anadir_log)->active == TRUE);
   pro->excluir_ftp = gtk_entry_get_text(GTK_ENTRY(datos.excluir_ftp));
   pro->niveles=gtk_entry_get_text(GTK_ENTRY(datos.niveles));
   pro->nc=(GTK_TOGGLE_BUTTON(datos.nc)->active==TRUE);
   pro->convert=(GTK_TOGGLE_BUTTON(datos.convert)->active==TRUE);
}


/*********** FIXME: Falta algunos valores, como niveles ****************/
/* Esta funcion altera la propiedad com del proyecto pro 
   asignandole val 
 */
void ponvalor(char *com,char *val, struct proyecto *pro)
{ 
  if (!strcasecmp(com,"NOMBRE"))
   pro->nombre=strdup(val);
  if (!strcasecmp(com,"URL"))
   pro->URL=strdup(val);
  if (!strcasecmp(com,"destino"))
   pro->dirdestino=strdup(val);
  if (!strcasecmp(com,"logfile"))
   pro->ficheroLOG=strdup(val);
  if (!strcasecmp(com,"recursivo"))
  { if (!strcasecmp(val,"true"))
      	pro->recursivo=1;
     else
        pro->recursivo=0;
  }
  if(!strcasecmp(com,"fichero"))
   pro->ficheroURL=strdup(val);
  if(!strcasecmp(com,"accept"))
   pro->aceptar=strdup(val);
  if(!strcasecmp(com,"reject"))
   pro->rechazar=strdup(val);
  if(!strcasecmp(com,"dominios"))
   pro->dominios=strdup(val);
  if(!strcasecmp(com,"continuar"))
  { if (!strcasecmp(val,"true"))
        pro->continuar=1;
    else
        pro->continuar=0;
  }


  if(!strcasecmp(com,"niveles"))
  { pro->niveles=strdup(val);
  }  
  if(!strcasecmp(com,"seguirftp"))
  { if (!strcasecmp(val,"true"))
        pro->seguir_a_ftp=1;
    else
        pro->seguir_a_ftp=0;   
  } 
  if (!strcasecmp(com,"anadirlog"))
  { if (!strcasecmp(val,"true"))
        pro->anadirLOG=1;
    else
        pro->anadirLOG=0;     
  }
  if(!strcasecmp(com,"excluir_ftp"))
     pro->excluir_ftp=strdup(val);
  if (!strcasecmp(com,"userftp"))
     gtk_entry_set_text(GTK_ENTRY(pro->userftp),val);

  if (!strcasecmp(com,"passftp"))
     gtk_entry_set_text(GTK_ENTRY(pro->passftp),val);

  if (!strcasecmp(com,"mirror"))
  	 { if (!strcasecmp(val,"true"))
  	   GTK_TOGGLE_BUTTON(pro->mirror)->active=TRUE;
  	   else
  	   GTK_TOGGLE_BUTTON(pro->mirror)->active=FALSE;
  	 }
  if (!strcasecmp(com,"tries"))
     gtk_entry_set_text(GTK_ENTRY(pro->tries),val);

  if(!strcasecmp(com,"existingfiles"))
	{ if (!strcasecmp(val,"true"))
	  pro->nc=1;
     else
	  pro->nc=0;
   } 
  if (!strcasecmp(com,"convert"))
	{ if (!strcasecmp(val,"true"))
	       pro->convert=1;
     else
	  pro->convert=0;
   }    
}

void setdefaults(void)
{ 
   datos.ficheroopc=NULL;
   datos.hayfichero=0;
   gtk_entry_set_text(GTK_ENTRY(datos.proyecto),"");
   gtk_entry_set_text(GTK_ENTRY(datos.url),"");
   gtk_entry_set_text(GTK_ENTRY(datos.accept),"");
   gtk_entry_set_text(GTK_ENTRY(datos.reject),"");
   gtk_entry_set_text(GTK_ENTRY(datos.fichero),"");
   gtk_entry_set_text(GTK_ENTRY(datos.logfile),"");
   gtk_entry_set_text(GTK_ENTRY(datos.destino),getenv("HOME"));
   GTK_TOGGLE_BUTTON(datos.anadir_log)->active=FALSE;
   GTK_TOGGLE_BUTTON(datos.recursivo)->active=FALSE;
   
   GTK_TOGGLE_BUTTON(datos.continuar)->active=FALSE;
   GTK_TOGGLE_BUTTON(datos.seguir_ftp)->active=FALSE;
   GTK_TOGGLE_BUTTON(datos.ver_ventana)->active=TRUE;
   GTK_TOGGLE_BUTTON(datos.parent)->active=FALSE;
   GTK_TOGGLE_BUTTON(datos.mirror)->active=FALSE;
   GTK_TOGGLE_BUTTON(datos.nc)->active=FALSE;
   GTK_TOGGLE_BUTTON(datos.convert)->active=FALSE;

   gtk_entry_set_text(GTK_ENTRY(datos.dominios),"");
   gtk_entry_set_text(GTK_ENTRY(datos.excluir_ftp),"");
   gtk_entry_set_text(GTK_ENTRY(datos.userftp),"");
   gtk_entry_set_text(GTK_ENTRY(datos.passftp),"");
   gtk_entry_set_text(GTK_ENTRY(datos.tries),"");
   gtk_entry_set_text(GTK_ENTRY(datos.niveles),"1");
   gtk_main_iteration();
}

/* Carga el fichero y asigna los valores con ponvalor() y update() 
 */
void cargafichero(GtkWidget *widget,GtkWidget *win)

{ struct proyecto pro; 
  char *s;
  s=gtk_file_selection_get_filename(GTK_FILE_SELECTION(widget));
  
  setdefaults();
  inipro(&pro);
  cargar(s,&pro);
  update(pro);
  finpro(&pro);
  gtk_widget_destroy(widget);
}

/* Carga un prototipo y asigna los valores corespondientes al entorno... 
 */
void cargaprototipo(char *nomproyecto)
{ 
  
  struct proyecto pro; 
/*  inipro(&pro); */
  consult(&pro);
  cargar(nomproyecto,&pro);
  update(pro);
/*  finpro(&pro); */

}
/* Funcion generica para cargar un fichero */
void cargar(char *nomfichero,struct proyecto *pro)
{ FILE *f;
  char *line;
  char *com,*val;
  int stat,longitud;


  f=fopen(nomfichero,"r");
  if (!f)
   { printf(_("******** Can't open file! *********"));
    return;
   }
  
  datos.hayfichero=1;
  free(datos.ficheroopc);
  datos.ficheroopc=(char*)malloc(100);
  strcpy(datos.ficheroopc,nomfichero);
  while((line=lee_linea(f)))
  { longitud=strlen(line);
     if (longitud && line[longitud-1]=='\r')
        line[longitud-1]='\0';
     stat=parse_line((unsigned char *)line,(unsigned char**)&com,
        	(unsigned char**)&val);
     free(line);
     if (stat==1)
      { 
        ponvalor(com,val,pro);
        free(com);
        free(val);
      }  
  }
  fclose(f);
}
  
/* Crea el dialogo de elegir fichero y ejecuta cargafichero() si se pulsa ok 
 */
void cargardialog(GtkWidget *widget,gpointer data)
{  static GtkWidget *window=NULL;
  
  
  if (!window)
  {
   window=gtk_file_selection_new(_("Project Name"));

  gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(window));
  gtk_signal_connect(GTK_OBJECT(window),"delete_event",
        	GTK_SIGNAL_FUNC(gtk_widget_destroyed),&window);
  gtk_signal_connect(GTK_OBJECT(window),"destroy",
        	GTK_SIGNAL_FUNC(gtk_widget_destroyed),&window);
  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(window)->cancel_button),
        	"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(window));

   gtk_container_border_width(GTK_CONTAINER(window),10);                
   gtk_file_selection_set_filename(GTK_FILE_SELECTION(window),datos.homewget);


   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(window)->ok_button),
     "clicked",GTK_SIGNAL_FUNC(cargafichero),GTK_OBJECT(window));
   
  }
  
  if (!GTK_WIDGET_VISIBLE(window))
     gtk_widget_show_all(window);
  else
     gtk_widget_destroy(window);
} 

/* Pone los valores por defecto. La llama la opcion New del Toolbar/menu  */
void newproject(GtkWidget *widget, gpointer data)
{
  datos.hayfichero=0;
  datos.ficheroopc=NULL;
  setdefaults();
  
}

