#ifndef fichero_h_
#define fichero_h_

#include <gtk/gtk.h>
#include "gwget.h"
#define DYNAMIC_LINE_BUFFER 40

int parse_line(const unsigned char *line,unsigned char **com,unsigned char **val);
void *nmalloc(size_t size);
void *nrealloc(void *obj,size_t size);
char *lee_linea(FILE *f);
void grabar(GtkWidget *widget,gpointer data);

/* Despliega un dialogo y graba el fichero de configuracion usando guardafich()
 */
void grabafichero(GtkWidget *widget,GtkWidget *win);

/* Crea el dialogo de elegir fichero y ejecuta cargafichero() si se pulsa ok 
 */
void cargardialog(GtkWidget *widget,gpointer data);

/* Carga un prototipo y asigna los valores corespondientes al entorno... 
 */
void cargaprototipo(char *nomproyecto);
/* Carga de fichero generica */
void cargar(char *nomfichero, struct proyecto *pro);

/* Guarda el entorno (Widget *datos) en el fichero nomfichero
 */
void guardafich(char *nomfichero);

/* Despliega el dialogo de elegir fichero y graba el entorno
 */
void grabarcomo(GtkWidget *widget, gpointer data);

/* Inicializa la variable pro
 */
void inipro(struct proyecto *pro);

/* Libera la variable pro 
 */
void finpro(struct proyecto *pro);

/* Asigna al entorno (Widget *datos) los valores de pro
 */
void update(struct proyecto pro);

/* Funcion que lee el entorno y lo coloca en pro (que debe estar inicializada)
 */
void consult(struct proyecto *pro);

/* Esta funcion altera la propiedad com del proyecto pro 
   asignandole val 
 */
void ponvalor(char *com,char *val, struct proyecto *pro);

/* Pone valores por defecto */
void setdefaults(void);

void newproject(GtkWidget *widget, gpointer data);

#endif
