#ifndef gwget_h_
#define gwget_h_

#include "./config.h"

#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/types.h>
#include <errno.h>
#include <stdio.h>
#include <gtk/gtk.h>

/* Internazionalizacion */
#ifndef ENABLE_NLS
#include <libintl.h>
#undef _
#define _(String) dgettext (PACKAGE, String)
#ifdef gettext_noop
#define N_(String) gettext_noop (String)
#else
#define N_(String) (String)
#endif
#else
/* Stubs that do something close enough.  */
#define textdomain(String) (String)
#define gettext(String) (String)
#define dgettext(Domain,Message) (Message)
#define dcgettext(Domain,Message,Type) (Message)
#define bindtextdomain(Domain,Directory) (Domain)
#define _(String) (String)
#define N_(String) (String)
#endif


#define version "Gwget 0.3.1"

/* buttonid contine un numero identificativo de quien es el boton que ha llamado */
/* a la fileselection */
/* 0=fich. con url; 1=dir. destino; 2=fich. de log; 3=proyecto */
gint buttonid; 

/* Datos que le paso a la funcion Lanzar! */
struct proyecto {
char *nombre; /* Nombre del proyecto */
char *fichero;
char *URL; /* si es NULL, las pilla del fichero */
char *ficheroURL; /* si !=NULL se usa */
char *ficheroLOG; /* evidente */
char *niveles; /* si es 0 recursion infinita */
int recursivo; /* tipo bool de toa la via */
char *dirdestino; /* directorio destino */
int continuar; /* continuar con el ftp (a cachos)  */
int seguir_a_ftp; /* seguir enlaces ftp en html (bool) */
char *excluir_ftp; /*lista de dir. a excluir de ftp */
char *dominios; /* dominios aceptados */
char *aceptar; /* extensiones a aceptar */
char *rechazar; /* extensiones a rechazar */
int anadirLOG; /* si se aade al fichero de log (bool) */
int parent; /* Ascender al directorio padre */ 
char *userftp; /* Nombre de usuario para FTP (por defecto es anonimo) */
char *passftp; /* Password para FTP */
int mirror; /* Activar el mirror */
char *tries; /* Numero de intentos */
int nc; /* not crobber */
int convert; /* convertir links no relativos a relativos localmente */
} datosproyecto;

/* Estructura que apuntara a los Widgets */

struct paf {
GtkWidget *proyecto,*url,*accept,*reject,*fichero,*logfile,*destino,*anadir_log,*recursivo;
GtkWidget *niveles,*dominios,*continuar,*seguir,*excluir_ftp,*seguir_ftp,*ver_ventana;
GtkWidget *parent,*userftp,*passftp,*mirror,*tries,*nc,*convert;
char homewget[1024];
int hayfichero; /* fichero de opciones (si lo tiene) */
char *ficheroopc; /* Nombre del fichero de opciones */
} datos;



#endif
