#include <unistd.h>
#include "launcher.h"
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>

#define MAXPROC 100

#define STARTED	1
#define FINITO	2


int pid;



/* Inicializa la lista de trabajos. Debe ejecutarse
antes de hacer nada */


/* Aade un trabajo a la lista y devuelve el numero */


/*Devuelve el nombre de un trabajo por su nombre */



/* Devuelve el numero de un trabajo por su nombre */

/* Devuelve el numero del primer trabajo existente */


/* Devuelve el numero del trabajo existente que
   va inmediatamente despues de n */


/* Devuelve la orden que hay que ejecutar para bajar datos */
/*
 * Ejecuta un comando en un proceso paralelo creado con fork y devuelve 
 * el pid. El segundo parametro es un fd que contendra la salida del programa.
 */

FILE *mipopen(char *command, int *pid)
{
   int tuberia[2];
   FILE *tmp;
   
   pipe(tuberia);	/* Ya tengo un pipe: tuberia[0] es de lectura */
   *pid = fork();
   if (*pid == -1)
      return NULL;		/* No he podido crear el proceso :( */
   if (*pid == 0) {	 		/* Proceso hijo... */
      char *arg[4];
 
      close(tuberia[0]);
      dup2(tuberia[1],STDOUT_FILENO);	/* Duplico el pipe en STDOUT */ 
      arg[0]="sh";
      arg[1]="-c";
      arg[2]=command;
      arg[3]=0;				/* Ejecuto el comando, y a partir de aqui */
      execve("/bin/sh",arg,NULL);	/* el hijo deja de existir };) */
   }
   close(tuberia[1]);   			/* Proceso padre... */
   tmp=fdopen(tuberia[0],"r");		/* Abro el fichero que contiene la salida */
   if(!tmp) {
      perror("mipopen");
      exit(1);
   }   
   return(tmp); 			/* Devuelve el fichero de salida */
}

int mipclose(FILE *f,int pid)
{
   int tmp;
   
   tmp=waitpid(pid,NULL,0);
   fclose(f);
   return(tmp);
}

void read_data(FILE *stream)
{ 
  static GtkWidget *window=NULL;
  GtkWidget *button,*vbox,*vscrollbar,*table,*text,*hscrollbar;

  char buffer[1024];
  int nchars;

  if (!window)
  {
   window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_policy(GTK_WINDOW(window),TRUE,TRUE,FALSE);
   
  

   gtk_signal_connect(GTK_OBJECT(window),"destroy",
        	GTK_SIGNAL_FUNC(gtk_widget_destroyed),&window);
                
   gtk_container_border_width(GTK_CONTAINER(window),10);
   gtk_window_set_title(GTK_WINDOW(window),_("wget output"));

   gtk_widget_set_usize(window,500,500);

   vbox=gtk_vbox_new(FALSE,10);
   gtk_widget_show(vbox);
   gtk_container_add(GTK_CONTAINER(window),vbox);

/* Hay que crear una tabla para poner a un lado el texto y a al lado la scrollbar */

   table=gtk_table_new(2,2,FALSE);
   gtk_table_set_row_spacing (GTK_TABLE(table),0,2);
   gtk_table_set_col_spacing(GTK_TABLE(table),0,2);
   gtk_box_pack_start(GTK_BOX(vbox),table,TRUE,TRUE,0);
   gtk_widget_show(table); 
   
   text = gtk_text_new(NULL,NULL);
  
   gtk_text_set_editable(GTK_TEXT(text),FALSE);
   gtk_table_attach(GTK_TABLE(table),text,0,1,0,1,
   					GTK_EXPAND | GTK_SHRINK | GTK_FILL,
   					GTK_EXPAND | GTK_SHRINK | GTK_FILL,0 ,0);
   gtk_widget_show(text); 

  hscrollbar=gtk_hscrollbar_new(GTK_TEXT(text)->hadj);
   gtk_table_attach(GTK_TABLE(table),hscrollbar,0,1,1,2,
   					GTK_EXPAND | GTK_FILL | GTK_SHRINK,GTK_FILL,0,0);
   gtk_widget_show(hscrollbar); 

   vscrollbar=gtk_vscrollbar_new(GTK_TEXT(text)->vadj);
   gtk_table_attach(GTK_TABLE(table),vscrollbar,1,2,0,1,
      					 GTK_FILL, GTK_EXPAND | GTK_SHRINK |GTK_FILL,0,0);
 gtk_widget_show(vscrollbar); 


 
  

  button=gtk_button_new_with_label(_("Close"));
  gtk_box_pack_start(GTK_BOX(vbox),button,FALSE,TRUE,10);
  gtk_signal_connect_object(GTK_OBJECT(button),"clicked",
  		GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(window));
  gtk_widget_show(button); 
 
  gtk_widget_show(window);

  gtk_text_thaw(GTK_TEXT(text));
  nchars=fread(buffer,sizeof(char),1024,stream);  
   while(nchars>0 && pid!=1)
      { 
        gtk_text_insert(GTK_TEXT(text),NULL,NULL,NULL,buffer,nchars);
        nchars=fread(buffer,sizeof(char),1024,stream);
      while (gtk_events_pending())
	      gtk_main_iteration();
      }

 
  
     
 }

/* if (!GTK_WIDGET_VISIBLE(window))
     gtk_widget_show_all(window);
     
  else
     gtk_widget_destroy(window);
 */

}

void stop(GtkWidget *widget, gpointer data)
{ 
   kill(pid,SIGINT);
   pid=1;
}

void Lanzar(void)
{  
   char llamada[1024];
  FILE *output;

      if (datosproyecto.userftp)
         sprintf(llamada,"wget ftp://%s:%s@%s ",datosproyecto.userftp,datosproyecto.passftp,datosproyecto.URL);  
      else 
         sprintf(llamada,"wget %s ",datosproyecto.URL);
	  if (datosproyecto.ficheroLOG) 
	  	sprintf(llamada,"%s -a %s",llamada, datosproyecto.ficheroLOG);
	  if (datosproyecto.dirdestino)
	  	sprintf(llamada,"%s -P %s",llamada, datosproyecto.dirdestino);
	  if (datosproyecto.dominios)
	  	sprintf(llamada,"%s -D %s",llamada, datosproyecto.dominios);
	  if (datosproyecto.aceptar)
	  	sprintf(llamada,"%s -A %s",llamada, datosproyecto.aceptar);
	  if (datosproyecto.rechazar)
	    sprintf(llamada,"%s -R %s",llamada, datosproyecto.rechazar);
	  if (datosproyecto.continuar)
	  	sprintf(llamada,"%s -c",llamada);
	  if (datosproyecto.recursivo)
	    sprintf(llamada,"%s -r",llamada);
	  if (datosproyecto.seguir_a_ftp)
	  	sprintf(llamada,"%s --follow-ftp",llamada);
	  if (datosproyecto.niveles)
	  	sprintf(llamada,"%s -l %s",llamada,datosproyecto.niveles);

	  if (datosproyecto.parent)
	    sprintf(llamada,"%s --no-parent",llamada);
	  if (datosproyecto.mirror)
	  	sprintf(llamada,"%s -m",llamada);

	  if (datosproyecto.tries)
	  	sprintf(llamada,"%s -t %s",llamada, datosproyecto.tries);
          
	  if (datosproyecto.nc)	
		sprintf(llamada,"%s -nc",llamada);	
	  if(datosproyecto.convert)
		sprintf(llamada,"%s -k",llamada);

	  

   output=mipopen(llamada,&pid);
    if (!output)
     { printf("I can't run wget!");
       exit(-1);
     }
   if (GTK_TOGGLE_BUTTON(datos.ver_ventana)->active) 
/*     tag1=gdk_input_add((gint)output,GDK_INPUT_READ,GTK_SIGNAL_FUNC(read_data),output); */
         read_data(output); 
   
   mipclose(output,pid); 
   
 
}

