#include "menu.h"

#ifdef GTK_HAVE_FEATURES_1_1_0

static GtkItemFactoryEntry menu_items[]= {
	{ "/_File",NULL,NULL,0,"<Branch>" } ,
	{ "/File/_New","<control>N",newproject,0,NULL },
	{ "/File/_Open","<control>O",cargardialog,0,NULL },
	{ "/File/_Save","<control>S",grabar,0,NULL },
	{ "/File/Save _As","<control>A",grabarcomo,0,NULL },
        { "/File/sep1",NULL,NULL,0,"<Separator>"},
	{ "/File/_Quit","<control>Q",gtk_main_quit,0,NULL} ,
	{ "/_Help",NULL,NULL,0,"<LastBranch>" } ,
	{ "/Help/About",NULL,about,0,NULL }
} ;
#endif	

void crea_menu(GtkWidget *window, GtkWidget **menubar)
{
#ifdef GTK_HAVE_FEATURES_1_1_0
GtkItemFactory *item_factory;
GtkAccelGroup *accel_group;
gint nmenu_items=sizeof(menu_items)/sizeof(menu_items[0]);

accel_group=gtk_accel_group_new();

	item_factory=gtk_item_factory_new(GTK_TYPE_MENU_BAR,"<main>",accel_group);
	gtk_item_factory_create_items(GTK_ITEM_FACTORY(item_factory),nmenu_items,
		menu_items,NULL);

	gtk_accel_group_attach(accel_group,GTK_OBJECT(window));
	
	if (menubar)
		*menubar=gtk_item_factory_get_widget(item_factory,"<main>");
#else
GtkWidget *barra_menu;
  GtkWidget *menu_archivo;
  GtkWidget *menu_about;
  GtkWidget *ayuda_item;
  GtkWidget *about_item;
  GtkWidget *archivo_item;
  GtkWidget *abrir_item;
  GtkWidget *guardar_como_item;
  GtkWidget *guardar_item;
  GtkWidget *salir_item;
  GtkWidget *separator_item;

  barra_menu=gtk_menu_bar_new();
  menu_archivo=gtk_menu_new();
  
  abrir_item=gtk_menu_item_new_with_label(_("Open"));
  guardar_item=gtk_menu_item_new_with_label(_("Save"));
  guardar_como_item=gtk_menu_item_new_with_label(_("Save as...")); 
  separator_item=gtk_menu_item_new();
  salir_item=gtk_menu_item_new_with_label(_("Exit"));
  archivo_item=gtk_menu_item_new_with_label(_("File"));

  gtk_menu_append(GTK_MENU(menu_archivo),abrir_item);
  gtk_menu_append(GTK_MENU(menu_archivo),guardar_item);
  gtk_menu_append(GTK_MENU(menu_archivo),guardar_como_item);
  gtk_menu_append(GTK_MENU(menu_archivo),separator_item);
  gtk_menu_append(GTK_MENU(menu_archivo),salir_item);

  gtk_signal_connect(GTK_OBJECT(salir_item),"activate",GTK_SIGNAL_FUNC(gtk_main_quit),NULL);
  gtk_signal_connect(GTK_OBJECT(abrir_item),"activate",GTK_SIGNAL_FUNC(cargardialog),NULL);
  gtk_signal_connect(GTK_OBJECT(guardar_item),"activate",GTK_SIGNAL_FUNC(grabar),NULL);
  gtk_signal_connect(GTK_OBJECT(guardar_como_item),"activate",GTK_SIGNAL_FUNC(grabarcomo),NULL);

  gtk_widget_show(abrir_item);
  gtk_widget_show(guardar_item);
  gtk_widget_show(guardar_como_item);
  gtk_widget_show(separator_item);
  gtk_widget_show(salir_item);
  
  gtk_widget_show(archivo_item);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(archivo_item),menu_archivo);
  gtk_menu_bar_append(GTK_MENU_BAR(barra_menu),archivo_item);

/* Menu about */
  menu_about=gtk_menu_new();

  about_item=gtk_menu_item_new_with_label(_("About..."));
  ayuda_item=gtk_menu_item_new_with_label(_("Help"));
  
  gtk_menu_append(GTK_MENU(menu_about),about_item);

  gtk_signal_connect(GTK_OBJECT(about_item),"activate",GTK_SIGNAL_FUNC(about),NULL);

  gtk_menu_item_right_justify(GTK_MENU_ITEM(ayuda_item));

  gtk_widget_show(about_item);
  gtk_widget_show(ayuda_item);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(ayuda_item),menu_about);
  gtk_menu_bar_append(GTK_MENU_BAR(barra_menu),ayuda_item);
  

  return barra_menu;
#endif
}  
