#include <gtk/gtk.h>
#include "minotebook.h"
#include "misventanas.h"
#include "pixmap.h"
void page_switch(GtkWidget *widget,GtkNotebookPage *page,gint page_num)
{
   GtkNotebookPage *oldpage;
   GtkWidget *pixwid;
   
   oldpage=GTK_NOTEBOOK(widget)->cur_page;
   
   if (page==oldpage)
      return;
      
   pixwid=((GtkBoxChild*)(GTK_BOX(page->tab_label)->children->data))->widget;
   gtk_pixmap_set(GTK_PIXMAP(pixwid),book_open,book_open_mask);
   pixwid=((GtkBoxChild*)(GTK_BOX(page->menu_label)->children->data))->widget;
   
   gtk_pixmap_set(GTK_PIXMAP(pixwid),book_open,book_open_mask);

   if (oldpage)
      { 
          pixwid=((GtkBoxChild*)(GTK_BOX(oldpage->tab_label)->children->data))->widget;
          gtk_pixmap_set(GTK_PIXMAP(pixwid),book_closed,book_closed_mask);
          pixwid=((GtkBoxChild*)(GTK_BOX(oldpage->menu_label)->children->data))->widget;
          gtk_pixmap_set(GTK_PIXMAP(pixwid),book_closed,book_closed_mask);
      }
}

void add_page(GtkNotebook *notebook,GtkWidget *child,char *etiqueta)
{ GtkWidget *label_box,*menu_box,*pixwid,*label;
  
  label_box=gtk_hbox_new(FALSE,0);
  pixwid=gtk_pixmap_new(book_closed,book_closed_mask);
  gtk_box_pack_start(GTK_BOX(label_box),pixwid,FALSE,TRUE,0);
  gtk_misc_set_padding(GTK_MISC(pixwid),3,1);
  label=gtk_label_new(etiqueta);
  gtk_box_pack_start(GTK_BOX(label_box),label,FALSE,TRUE,0);
  gtk_widget_show_all(label_box);
  
  menu_box=gtk_hbox_new(FALSE,0);
  pixwid=gtk_pixmap_new(book_closed,book_closed_mask);
  gtk_box_pack_start(GTK_BOX(menu_box),pixwid,FALSE,TRUE,0);
  gtk_misc_set_padding(GTK_MISC(pixwid),3,1);
  label=gtk_label_new(etiqueta);
  gtk_box_pack_start(GTK_BOX(menu_box),label,FALSE,TRUE,0);
  gtk_widget_show_all(menu_box);

  gtk_notebook_append_page_menu(notebook,child,label_box,menu_box);
    
}

void crear_paginas(GtkNotebook *notebook)
{ GtkWidget *child=NULL;
  GtkWidget *label,*vbox,*hbox;
  GtkWidget *input,*check,*button;
  
/*				   */
/* PAGINA DE CONFIGURACION GENERAL */
/*				   */

  child=gtk_frame_new("General");
  gtk_container_border_width(GTK_CONTAINER(child),10);
  
  vbox=gtk_vbox_new(TRUE,0);
  gtk_container_border_width(GTK_CONTAINER(vbox),10);
  gtk_container_add(GTK_CONTAINER(child),vbox);
  
  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,10);
  
  label=gtk_label_new(_("Save in : "));
  gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,10);
  gtk_widget_show(label);

  
  input=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox),input,FALSE,FALSE,10);
  datos.destino=input; 
  gtk_entry_set_text(GTK_ENTRY(input),getenv("HOME"));
  gtk_widget_show(input);

  button=gtk_button_new_with_label(_("Browse"));
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,25);
  gtk_signal_connect_object(GTK_OBJECT(button),"clicked",
	  GTK_SIGNAL_FUNC(GtkExaminar),(gpointer)1); 
  gtk_widget_show(button);

  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,10);

  
  label=gtk_label_new(_("Log File : "));
  gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,0);
  gtk_widget_show(label);

  input=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox),input,FALSE,FALSE,0);
  datos.logfile=input; 
  gtk_widget_show(input);

  check=gtk_check_button_new_with_label(_("Add"));
  gtk_box_pack_start(GTK_BOX(hbox),check,FALSE,FALSE,0);
  datos.anadir_log=check; 
  gtk_widget_show(check);

  button=gtk_button_new_with_label(_("Browse"));
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);
  gtk_signal_connect_object(GTK_OBJECT(button),"clicked",
	  GTK_SIGNAL_FUNC(GtkExaminar),(gpointer)2);
  gtk_widget_show(button);


  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);

  
  check=gtk_check_button_new_with_label(_("View log window"));
  gtk_box_pack_start(GTK_BOX(hbox),check,FALSE,FALSE,0);
  datos.ver_ventana=check; 
  GTK_TOGGLE_BUTTON(check)->active=TRUE;
  gtk_widget_show(check);
 

  label=gtk_label_new(_("N Tries : "));
  gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,0);
  gtk_widget_show(label);

  input=gtk_entry_new();
  datos.tries=input;
  gtk_box_pack_start(GTK_BOX(hbox),input,TRUE,TRUE,0);
  gtk_widget_show(input);

  gtk_widget_show_all(child);    
  add_page(GTK_NOTEBOOK(notebook),child,"General");
  
/* 					      */
/* PAGINA DE CONFIGURACION DE LA RECURSIVIDAD */
/*					      */
  child=gtk_frame_new(_("Recursive"));
  gtk_container_border_width(GTK_CONTAINER(child),10);
  
  vbox=gtk_vbox_new(TRUE,0);
  gtk_container_border_width(GTK_CONTAINER(vbox),10);
  gtk_container_add(GTK_CONTAINER(child),vbox);
  
  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);

  check=gtk_check_button_new_with_label(_("Recursive"));
  gtk_box_pack_start(GTK_BOX(hbox),check,TRUE,TRUE,0);
  datos.recursivo=check; 
  gtk_widget_show(check);

  label=gtk_label_new(_("N Levels : "));
  gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,0);
  gtk_widget_show(label);

  input=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox),input,TRUE,TRUE,0);
  gtk_entry_set_text(GTK_ENTRY(input),"1");
  datos.niveles=input; 
  gtk_widget_show(input);


  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);

  label=gtk_label_new(_("Accept Domains : "));
  gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,0);
  gtk_widget_show(label);

  input=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox),input,TRUE,TRUE,0);
  datos.dominios=input;
  gtk_widget_show(input);

  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);

   
  check=gtk_check_button_new_with_label(_("Don't retrive existing files"));
  gtk_box_pack_start(GTK_BOX(hbox),check,TRUE,TRUE,0);
  datos.nc=check; 
  gtk_widget_show(check);

  check=gtk_check_button_new_with_label(_("Convert non-relative links to relative ones locally"));
  gtk_box_pack_start(GTK_BOX(hbox),check,TRUE,TRUE,0);
  datos.convert=check; 
  gtk_widget_show(check);

  gtk_widget_show_all(child);    
  add_page(GTK_NOTEBOOK(notebook),child,_("Recursivity"));

/*					*/
/*	PAGINA CONFIGURACION FTP	*/
/*					*/
  child=gtk_frame_new("Ftp");
  gtk_container_border_width(GTK_CONTAINER(child),10);
  
  vbox=gtk_vbox_new(TRUE,0);
  gtk_container_border_width(GTK_CONTAINER(vbox),10);
  gtk_container_add(GTK_CONTAINER(child),vbox);
  
  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);

  check=gtk_check_button_new_with_label(_("Continue"));
  gtk_box_pack_start(GTK_BOX(hbox),check,TRUE,TRUE,0);
  datos.continuar=check; 
  gtk_widget_show(check);

  check=gtk_check_button_new_with_label(_("Follow from html"));
  gtk_box_pack_start(GTK_BOX(hbox),check,TRUE,TRUE,0);
  datos.seguir_ftp=check; 
  gtk_widget_show(check);
  

  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);

  label=gtk_label_new(_("Exclude directories : "));
  gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,0);
  gtk_widget_show(label);
  
  input=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox),input,TRUE,TRUE,0);
  datos.excluir_ftp=input; 
  gtk_widget_show(input);
 
  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);

  label=gtk_label_new(_("User : "));
  gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,0);
  gtk_widget_show(label);

  input=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox),input,TRUE,TRUE,0);
  datos.userftp=input; 
  gtk_widget_show(input);

  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);

  label=gtk_label_new(_("Password : "));
  gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,0);
  gtk_widget_show(label);

  input=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox),input,TRUE,TRUE,0);
  gtk_entry_set_visibility(GTK_ENTRY(input),FALSE);
  datos.passftp=input; 
  gtk_widget_show(input);

  gtk_widget_show_all(child);    
  add_page(GTK_NOTEBOOK(notebook),child,"Ftp");

/*                          */
/*  PAGINA DE AVANZADO      */
/*                          */
  child=gtk_frame_new(_("Advanced"));
  gtk_container_border_width(GTK_CONTAINER(child),10);
  
  vbox=gtk_vbox_new(TRUE,0);
  gtk_container_border_width(GTK_CONTAINER(vbox),10);
  gtk_container_add(GTK_CONTAINER(child),vbox);
  
  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);

/* Aki deben ir las opciones */

  label=gtk_label_new(_("Accept Extensions  : "));
  gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,10);


  input=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox),input,TRUE,TRUE,10);
  datos.accept=input; 

  

  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  
  label=gtk_label_new(_("Reject Extensions : "));
  gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,10);
  gtk_widget_show(label);
  
  input=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox),input,TRUE,TRUE,10);
  datos.reject=input; 
  gtk_widget_show(input);
  
  hbox=gtk_hbox_new(TRUE,0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);

  check=gtk_check_button_new_with_label(_("Do not ascend to parent directory"));
  gtk_box_pack_start(GTK_BOX(hbox),check,TRUE,TRUE,0);
  datos.parent=check; 
  gtk_widget_show(check);

  check=gtk_check_button_new_with_label(_("Mirror"));
  gtk_box_pack_start(GTK_BOX(hbox),check,TRUE,TRUE,0);
  datos.mirror=check; 
  gtk_widget_show(check);

  gtk_widget_show_all(child);    
  add_page(GTK_NOTEBOOK(notebook),child,_("Advanced"));



}

