#include <gtk/gtk.h>
#include <sys/types.h>
#include <dirent.h>
#include "fichero.h"
#include <stdio.h>
#include <strings.h>

const gchar *list_item_data_key="list_item_data";

/* Esta funcion devuelve una cadena que contiene el texto de las lineas del fichero que
   empiezen con #.		
   Es una funcion que deberia estar en la libc de lo util que es ;) */
char *getrem(char *name)
{
	FILE *f;
	char *s;
        char *texto;

	f=fopen(name,"r");
	s=malloc(200);
        texto=malloc(1000);
        if(!texto) {
           perror("Algo ha ido mal");
           exit(-1);
        }
		strcpy(texto,"");
        while(!feof(f)) {
           if(fgets(s,200,f)) 
              if(s[0]=='#') 
                 strcat(texto,strdup(s+1));
        }
        return (texto);
	fclose(f);
}

/* Esta funcion se ejecuta cuando se pulsa el boton Elegir.
   Debe leer el contenido del prototipo y establecerlo en el entorno.
*/
void confproto(GtkWidget *widget, gpointer *list)
{
   GList *lista=NULL;
   char texto[70];
   gchar *eleccion = NULL;
 
   lista=GTK_LIST(list)->selection;
   while (lista) {
         GtkObject *list_item;
         list_item=GTK_OBJECT(lista->data);
         eleccion=gtk_object_get_data(list_item,list_item_data_key);
         lista=lista->next;
   
   } 
  sprintf(texto,"%s/.gwget/prototypes/%s",getenv("HOME"),eleccion);         
  cargaprototipo(texto);
}

/* Se ejecuta al seleccionar un elemento de la lista */
void elem_selec( GtkWidget *list,gpointer data)
{
   gchar *eleccion=NULL;
   GList *lista=NULL;
   char *filename;

   lista=GTK_LIST(list)->selection;
   while (lista) {
         GtkObject *list_item;
         list_item=GTK_OBJECT(lista->data);
         eleccion=gtk_object_get_data(list_item,list_item_data_key);
         lista=lista->next;
   } 
   if(eleccion) {
      filename=malloc(200);
      sprintf(filename,"%s/.gwget/prototypes/%s",getenv("HOME"),eleccion);
      gtk_label_set_text(GTK_LABEL(data),getrem(filename));         
      free(filename);
   }
}

/* Crea el dialogo para elegir prototipo si este no existe */
void
prototipo(GtkWidget *widget, gpointer dato)
{
  static GtkWidget *window = NULL;
  static char *items;

  GtkWidget *box1;
  GtkWidget *box2;
  GtkWidget *boxmsg;
  GtkWidget *scrolled_win;
  GtkWidget *list;
  GtkWidget *list_item;
  GtkWidget *button;
  GtkWidget *separator,*label;
  GtkWidget *message;

  char *nombredir;
  struct dirent *data;
  DIR *direc;

  if (!window)
    {
      window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

      gtk_signal_connect (GTK_OBJECT (window), "destroy",
			  GTK_SIGNAL_FUNC(gtk_widget_destroyed),
			  &window);

      gtk_window_set_title (GTK_WINDOW (window), "Prototypes");
      gtk_container_border_width (GTK_CONTAINER (window), 0);

      gtk_widget_set_usize(window,160,200);
      
      box1 = gtk_vbox_new (FALSE, 0);

      gtk_container_add (GTK_CONTAINER (window), box1);
      gtk_widget_show (box1);


      box2 = gtk_vbox_new (FALSE, 10);
      gtk_container_border_width (GTK_CONTAINER (box2), 10);
      gtk_box_pack_start (GTK_BOX (box1), box2, TRUE, TRUE, 0);
      gtk_widget_show (box2);


      scrolled_win = gtk_scrolled_window_new (NULL, NULL);
      gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
				      GTK_POLICY_AUTOMATIC, 
				      GTK_POLICY_AUTOMATIC);
      gtk_box_pack_start (GTK_BOX (box2), scrolled_win, TRUE, TRUE, 0);
      gtk_widget_show (scrolled_win);

      list = gtk_list_new ();
      gtk_list_set_selection_mode (GTK_LIST (list), GTK_SELECTION_MULTIPLE);
      gtk_list_set_selection_mode (GTK_LIST (list), GTK_SELECTION_BROWSE);
#ifdef GTK_HAVE_FEATURES_1_1_0
      gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_win), list);
#else 
      gtk_container_add (GTK_CONTAINER (scrolled_win), list);
#endif
      gtk_container_set_focus_vadjustment (GTK_CONTAINER (list),
					   gtk_scrolled_window_get_vadjustment (GTK_SCROLLED_WINDOW (scrolled_win)));
      gtk_widget_show (list);

      /* Aqui se aaden los elementos de la lista... */
 	nombredir=(char *)malloc(200); 
   	sprintf(nombredir,"%s/.gwget/prototypes",getenv("HOME"));
     	direc=opendir(nombredir);
        data=readdir(direc);
    
	while(data!=NULL)
	{  gchar *string;

	      items=strdup(data->d_name);
          
          if(items[0]!='.')
          {  
             label=gtk_label_new(items);
             list_item = gtk_list_item_new();
             gtk_container_add(GTK_CONTAINER(list_item),label);
             gtk_widget_show(label);
             gtk_container_add (GTK_CONTAINER (list), list_item);
             gtk_widget_show (list_item);
             gtk_label_get(GTK_LABEL(label),&string);
             gtk_object_set_data(GTK_OBJECT(list_item),list_item_data_key,string);  
          }
          data=readdir(direc);
	}
        free(nombredir);

      separator = gtk_hseparator_new ();
      gtk_box_pack_start (GTK_BOX (box1), separator, FALSE, TRUE, 0);
      gtk_widget_show (separator);

      boxmsg = gtk_vbox_new (FALSE, 10);
      gtk_container_border_width(GTK_CONTAINER (boxmsg), 0);
      gtk_box_pack_start (GTK_BOX (box1), boxmsg, FALSE, TRUE, 0);
      gtk_widget_show (boxmsg);
      
      message = gtk_label_new("");
      gtk_box_pack_start (GTK_BOX (boxmsg), message, FALSE, TRUE, 0);
      gtk_widget_show (message);

      /* Esta funcion hace que al seleccionar el nombre aparezca */
      gtk_signal_connect(GTK_OBJECT (list), 
         		"selection_changed", 
                        GTK_SIGNAL_FUNC(elem_selec),
                        message);

      
      box2 = gtk_vbox_new (FALSE, 10);
      gtk_container_border_width (GTK_CONTAINER (box2), 0);
      gtk_box_pack_start (GTK_BOX (box1), box2, FALSE, TRUE, 0);
      gtk_widget_show (box2);

/* Hacer la funcion que aade el prototipo... */
      button = gtk_button_new_with_label ("Choose");
      gtk_signal_connect(GTK_OBJECT (button), "clicked",
				 GTK_SIGNAL_FUNC(confproto),
                                  GTK_OBJECT(list));
      gtk_box_pack_start (GTK_BOX (box2), button, TRUE, TRUE, 0);
      GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
      gtk_widget_grab_default (button);
      gtk_widget_show (button);
    }

  if (!GTK_WIDGET_VISIBLE (window))
    gtk_widget_show (window);
  else
    gtk_widget_destroy (window);
}


